
#https://bioconductor.org/packages/devel/bioc/vignettes/ChemmineR/inst/doc/ChemmineR.html#introduction

#To install Packages 

#if (!requireNamespace("BiocManager", quietly=TRUE))
#  install.packages("BiocManager")
#BiocManager::install("ChemmineR")

#Using the package
library("ChemmineR")


library(help="ChemmineR") # Lists all functions and classes 
vignette("ChemmineR") # Opens this PDF manual from R 

#An instance of "SDFset" with 100 molecules
data(sdfsample) 
sdfset <- sdfsample
sdfset # Returns summary of SDFset 

sdfset[1:4] # Subsetting of object

sdfset[[1]]


sdfset <- read.SDFset("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/Samples/sdfsample.sdf") 

header(sdfset[[1]])

atomblock(sdfset[[1]])[1:4,] 

bondblock(sdfset[[1]])[1:4,] 

datablock(sdfset[[1]])[1:4] 

cid(sdfset)[1:4] # Returns IDs from SDFset object

sdfid(sdfset)[1:4] # Returns IDs from SD file header block

unique_ids <- makeUnique(sdfid(sdfset)) # check duplicates
cid(sdfset) <- unique_ids 

#Converting the data blocks in an SDFset to a matrix
blockmatrix <- datablock2ma(datablocklist=datablock(sdfset)) # Converts data block to matrix 
numchar <- splitNumChar(blockmatrix=blockmatrix) # Splits to numeric and character matrix 
numchar[[1]][1:2,1:2] # Slice of numeric matrix 


numchar[[2]][1:2,10:11] # Slice of character matrix 

#Compute atom frequency matrix, molecular weight and formula:

propma <- data.frame(MF=MF(sdfset), MW=MW(sdfset), atomcountMA(sdfset))
propma[1:4, ] 

#Assign matrix data to data block:
datablock(sdfset) <- propma 

#String searching in SDFset:

grepSDFset("650001", sdfset, field="datablock", mode="subset") # Returns summary view of matches. Not printed here.
grepSDFset("650001", sdfset, field="datablock", mode="index") 
datablock(sdfset[1]) 

#Export SDFset to SD file:
write.SDF(sdfset[1:4], file="sub.sdf", sig=TRUE) 

plot(sdfset[1:4], print=FALSE) # Plots structures to R graphics device 


